'simple parking game test .2012 . alfakilo@email.ee
#Include "fbgfx.bi" 
#Include "Data/multiput.bi"' by D.J.Peters (Joshy)
'CAR START
Const PI = 3.141593
Type car
	carLocationx As Single=50
	carLocationy As Single=50
	frontWheelx As Single
	frontWheely As Single
	backWheelx As Single
	backWheely As Single
	dt As Single
	carheading As Single
	carspeed As Single
	steerangle As Single
	wheelbase As Single =150
End Type

Sub car_update( a As car )
	
a.frontWheelX = a.carLocationX + a.wheelBase/2 * cos(a.carHeading)
a.frontWheelY = a.carLocationY + a.wheelBase/2 * sin(a.carHeading)

a.backWheelX = a.carLocationX - a.wheelBase/2 * cos(a.carHeading)
a.backWheelY = a.carLocationY - a.wheelBase/2 * sin(a.carHeading)

a.backWheelX += a.carSpeed * a.dt * cos(a.carHeading)
a.backWheelY += a.carSpeed * a.dt * sin(a.carHeading)

a.frontWheelX += a.carSpeed * a.dt * cos(a.carHeading+a.steerAngle)
a.frontWheelY += a.carSpeed * a.dt * sin(a.carHeading+a.steerAngle)

a.carLocationX = (a.frontWheelX + a.backWheelX) / 2
a.carLocationY = (a.frontWheelY + a.backWheelY) / 2

a.carHeading = atan2( a.frontWheelY - a.backWheelY , a.frontWheelX - a.backWheelX )
	
End Sub
'CAR END

Type world
	x As Integer
	y As Integer
	tyyp As Integer
	img_f As Integer
End Type
Dim blocks(1 To 1000) As world






'READ MAP
Dim As Integer block_count
Dim As Integer fg = Freefile
Open "data/map.o" For input As  #fg
input #fg,block_count
For i As Integer=1 To block_count
Input #fg,blocks(i).x,blocks(i).y,blocks(i).tyyp,blocks(i).img_f
Next
Close #fg



'CAR PLAYER
Dim Shared rong As car
rong.wheelbase=70

Dim As Integer dev=1
Dim As Single bx,by
Dim As Integer status(2)
Dim As String ekey


'SCREEN
Screenres 640, 480, 32

'IMAGES LOAD
Dim Shared As Any Ptr tr:tr = ImageCreate( 74, 29 ) :BLoad "Data/tr.bmp",tr 
Dim Shared As Any Ptr ground:ground = ImageCreate( 640, 480 ) :BLoad "Data/ground.bmp",ground
Dim Shared As Any Ptr rr:rr = ImageCreate( 5, 29 ) :BLoad "Data/r.bmp",rr 
Dim Shared As Any Ptr ims(1 To 11)
ims(1) = ImageCreate( 20, 20 ) :BLoad "Data/a1.bmp",ims(1)
ims(2) = ImageCreate( 20, 20 ) :BLoad "Data/a2.bmp",ims(2)
ims(3) = ImageCreate( 20, 20 ) :BLoad "Data/a3.bmp",ims(3)
ims(4) = ImageCreate( 20, 20 ) :BLoad "Data/a4.bmp",ims(4)
ims(5) = ImageCreate( 20, 20 ) :BLoad "Data/b1.bmp",ims(5)
ims(6) = ImageCreate( 20, 20 ) :BLoad "Data/b2.bmp",ims(6)
ims(7) = ImageCreate( 20, 20 ) :BLoad "Data/b3.bmp",ims(7)
ims(8) = ImageCreate( 20, 20 ) :BLoad "Data/b4.bmp",ims(8)
ims(9) = ImageCreate( 20, 20 ) :BLoad "Data/c.bmp",ims(9)
ims(10) = ImageCreate( 40, 40 ) :BLoad "Data/bs.bmp",ims(10)'bs f
ims(11) = ImageCreate( 40, 40 ) :BLoad "Data/bv.bmp",ims(11)'bs b



'MAIN
Do
bx=rong.carLocationX
by=rong.carLocationy


Sleep 10
ScreenLock
Cls

Put (0,0), ground, Trans

For i As Integer=1 To block_count	
If blocks(i).img_f=1 Then MultiPUT,blocks(i).x, blocks(i).y,ims(1),,,0,1'sein
If blocks(i).img_f=2 Then MultiPUT,blocks(i).x, blocks(i).y,ims(2),,,0,1'sein
If blocks(i).img_f=3 Then MultiPUT,blocks(i).x, blocks(i).y,ims(3),,,0,1'sein
If blocks(i).img_f=4 Then MultiPUT,blocks(i).x, blocks(i).y,ims(4),,,0,1'sein
If blocks(i).img_f=5 Then MultiPUT,blocks(i).x, blocks(i).y,ims(5),,,0,1'sein
If blocks(i).img_f=6 Then MultiPUT,blocks(i).x, blocks(i).y,ims(6),,,0,1'sein
If blocks(i).img_f=7 Then MultiPUT,blocks(i).x, blocks(i).y,ims(7),,,0,1'sein
If blocks(i).img_f=8 Then MultiPUT,blocks(i).x, blocks(i).y,ims(8),,,0,1'sein
If blocks(i).img_f=9 Then MultiPUT,blocks(i).x, blocks(i).y,ims(9),,,0,1'sein
If blocks(i).img_f=10 Then MultiPUT,blocks(i).x, blocks(i).y,ims(10),,,0,1'sein
If blocks(i).img_f=11 Then MultiPUT,blocks(i).x, blocks(i).y,ims(11),,,0,1'sein

Next

If dev=1 Then MultiPUT,rong.backWheelX, rong.backWheely,rr,,,(rong.carHeading*180)/PI,1'ball
If dev=1 Then MultiPUT,rong.frontWheelX, rong.frontWheely,rr,,,((rong.carHeading+rong.steerAngle)*180)/PI,1'ball
MultiPUT,rong.carLocationX, rong.carLocationy,tr,,,(rong.carHeading*180)/PI,1'ball


If status(1)=1 And status(2)=1 Then
	Print "Status : parked" 
Else
	Print "Status : NOT parked" 
EndIf

ScreenUnLock
	



'MOVE
If MultiKey(FB.SC_UP) Then 
rong.carSpeed =1 :rong.dt=1
EndIf

If MultiKey(FB.SC_DOWN) Then 
rong.carSpeed =-1  :rong.dt=1
EndIf

If MultiKey(FB.SC_UP)=0 And MultiKey(FB.SC_DOWN)=0 Then
	If rong.carspeed >0 Then rong.carSpeed -=0.01
	if rong.dt >0 Then rong.dt -=0.05
	if rong.dt<0 Then rong.dt =0
EndIf

'ROTATE
If MultiKey(FB.SC_LEFT) And rong.steerAngle> -1 Then rong.steerAngle -=.05

If MultiKey(FB.SC_RIGHT)  And rong.steerAngle< 1 Then rong.steerAngle +=.05	


	

'UPDATE
status(1)=0
status(2)=0
car_update( rong )





'COLLISION Im weak at this
' y y x x
For i As Integer=1 To block_count	
	
If blocks(i).tyyp=1 Then'sein
If Sqr((rong.carLocationy-blocks(i).y)^2+(rong.carLocationx-blocks(i).x)^2)<20 Then 
	Print "impact1"
	rong.carLocationy=by
	rong.carLocationx=bx
EndIf
If Sqr((rong.frontWheely-blocks(i).y)^2+(rong.frontWheelX-blocks(i).x)^2)<15 Then 
	Print "impact2"
	rong.carLocationy=by
	rong.carLocationx=bx
EndIf
If Sqr((rong.backWheely-blocks(i).y)^2+(rong.backWheelX-blocks(i).x)^2)<15 Then 
	Print "impact3"
	rong.carLocationy=by
	rong.carLocationx=bx
EndIf
EndIf


'PARKING AREA
If blocks(i).tyyp=2 Then'spot for front wheel
If Sqr((rong.frontWheely-blocks(i).y)^2+(rong.frontWheelX-blocks(i).x)^2)<20 Then 
	status(1)=1
EndIf
EndIf
If blocks(i).tyyp=3 Then'spot for front wheel
If Sqr((rong.backWheely-blocks(i).y)^2+(rong.backWheelX-blocks(i).x)^2)<20 Then 
	status(2)=1
EndIf
EndIf

Next






ekey = InKey
Loop Until ekey= Chr(27) Or ekey=Chr(255, 107)
end
'E_O_F